/**
 * generated by Xtext 2.21.0
 */
package br.ufes.nemo.seon.ontoloyasservice.oaas.impl;

import br.ufes.nemo.seon.ontoloyasservice.oaas.AbstractElement;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Application;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Configuration;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Application</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.impl.ApplicationImpl#getConfiguration <em>Configuration</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.impl.ApplicationImpl#getAbstractElements <em>Abstract Elements</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ApplicationImpl extends MinimalEObjectImpl.Container implements Application
{
  /**
   * The cached value of the '{@link #getConfiguration() <em>Configuration</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConfiguration()
   * @generated
   * @ordered
   */
  protected Configuration configuration;

  /**
   * The cached value of the '{@link #getAbstractElements() <em>Abstract Elements</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAbstractElements()
   * @generated
   * @ordered
   */
  protected EList<AbstractElement> abstractElements;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ApplicationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return OaasPackage.Literals.APPLICATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Configuration getConfiguration()
  {
    return configuration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetConfiguration(Configuration newConfiguration, NotificationChain msgs)
  {
    Configuration oldConfiguration = configuration;
    configuration = newConfiguration;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, OaasPackage.APPLICATION__CONFIGURATION, oldConfiguration, newConfiguration);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setConfiguration(Configuration newConfiguration)
  {
    if (newConfiguration != configuration)
    {
      NotificationChain msgs = null;
      if (configuration != null)
        msgs = ((InternalEObject)configuration).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - OaasPackage.APPLICATION__CONFIGURATION, null, msgs);
      if (newConfiguration != null)
        msgs = ((InternalEObject)newConfiguration).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - OaasPackage.APPLICATION__CONFIGURATION, null, msgs);
      msgs = basicSetConfiguration(newConfiguration, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, OaasPackage.APPLICATION__CONFIGURATION, newConfiguration, newConfiguration));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<AbstractElement> getAbstractElements()
  {
    if (abstractElements == null)
    {
      abstractElements = new EObjectContainmentEList<AbstractElement>(AbstractElement.class, this, OaasPackage.APPLICATION__ABSTRACT_ELEMENTS);
    }
    return abstractElements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case OaasPackage.APPLICATION__CONFIGURATION:
        return basicSetConfiguration(null, msgs);
      case OaasPackage.APPLICATION__ABSTRACT_ELEMENTS:
        return ((InternalEList<?>)getAbstractElements()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case OaasPackage.APPLICATION__CONFIGURATION:
        return getConfiguration();
      case OaasPackage.APPLICATION__ABSTRACT_ELEMENTS:
        return getAbstractElements();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case OaasPackage.APPLICATION__CONFIGURATION:
        setConfiguration((Configuration)newValue);
        return;
      case OaasPackage.APPLICATION__ABSTRACT_ELEMENTS:
        getAbstractElements().clear();
        getAbstractElements().addAll((Collection<? extends AbstractElement>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case OaasPackage.APPLICATION__CONFIGURATION:
        setConfiguration((Configuration)null);
        return;
      case OaasPackage.APPLICATION__ABSTRACT_ELEMENTS:
        getAbstractElements().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case OaasPackage.APPLICATION__CONFIGURATION:
        return configuration != null;
      case OaasPackage.APPLICATION__ABSTRACT_ELEMENTS:
        return abstractElements != null && !abstractElements.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ApplicationImpl
